<!--待处理 pending-->
<template>
  <div class="photonote-pending">
    <div class="photonote-pending-page" v-if="pageType == 1">
      <el-table v-loading="loading" border :data="photonoteList" @selection-change="handleSelectionChange">
        <el-table-column label="实验室名称" align="left" prop="subName" width="253" show-overflow-tooltip/>
        <el-table-column label="描述" align="left" prop="describe" show-overflow-tooltip/>
        <el-table-column label="反馈人" align="left" prop="applyName" width="170" show-overflow-tooltip/>
        <el-table-column label="提交时间" align="left" prop="createTimeStr2" width="250" show-overflow-tooltip/>
        <el-table-column label="操作" align="left" class-name="small-padding fixed-width" width="120" v-if="tableButtonType">
          <template slot-scope="scope">
            <div class="button-box" style="display: flex;margin-left:20px;">
              <p class="table-min-button"
                 @click="drawerBoxOn(scope.row)"
                 v-hasPermiAnd="['laboratory:photonote:query','laboratory:photonote:edit']"
              >详情</p>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total>0"
        :total="total"
        layout="total, prev, pager, next, sizes, jumper"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
      <!-- 添加或修改随手拍记录对话框
      <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
        <el-form ref="form" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="图片地址" prop="imgUrl">
            <el-input v-model="form.imgUrl" placeholder="请输入图片地址" />
          </el-form-item>
          <el-form-item label="处理人ID" prop="handleUser">
            <el-input v-model="form.handleUser" placeholder="请输入处理人ID" />
          </el-form-item>
          <el-form-item label="处理时间" prop="handleTime">
            <el-date-picker clearable size="small"
                            v-model="form.handleTime"
                            type="date"
                            value-format="yyyy-MM-dd"
                            placeholder="选择处理时间">
            </el-date-picker>
          </el-form-item>
          <el-form-item label="处理标记 0：待处理 1：已处理">
            <el-radio-group v-model="form.handleStatus">
              <el-radio label="1">请选择字典生成</el-radio>
            </el-radio-group>
          </el-form-item>
          <el-form-item label="部门id" prop="deptId">
            <el-input v-model="form.deptId" placeholder="请输入部门id" />
          </el-form-item>
          <el-form-item label="部门名称" prop="deptName">
            <el-input v-model="form.deptName" placeholder="请输入部门名称" />
          </el-form-item>
          <el-form-item label="创建人" prop="userId">
            <el-input v-model="form.userId" placeholder="请输入创建人" />
          </el-form-item>
          <el-form-item label="备注" prop="remark">
            <el-input v-model="form.remark" placeholder="请输入备注" />
          </el-form-item>
          <el-form-item label="实验室ID" prop="subjectId">
            <el-input v-model="form.subjectId" placeholder="请输入实验室ID" />
          </el-form-item>
          <el-form-item label="描述" prop="describe">
            <el-input v-model="form.describe" type="textarea" placeholder="请输入内容" />
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog> -->
    </div>
    <pending-info v-if="pageType == 2" :drawerData="drawerData"></pending-info>
    <!--处理-->
    <el-drawer
      class="photonote-pending-drawer"
      :visible.sync="drawer"
      direction="rtl"
      ref="drawer"
      :with-header="false"
      :show-close="false"
      :before-close="handleClose">
      <div class="photonote-pending-drawer-drawer-max-box">
        <div class="photonote-pending-drawer-drawer-content">
          <div>
            <p>实验室名称：</p>
            <p>{{drawerData.subName}}</p>
          </div>
          <div>
            <p>描述：</p>
            <p>{{drawerData.describe}}</p>
          </div>
          <div>
            <p>学生照片：</p>
          </div>
          <img class="photonote-pending-drawer-drawer-content-img" :src="item" v-for="(item,index) in drawerData.imgUrl" :key="index">
        </div>
        <div class="photonote-pending-drawer-bottom-button-box">
          <p></p>
          <p  @click="offDrawer" >关闭</p>
          <p  @click="handle(drawerData.id)" >处理</p>
        </div>
      </div>
    </el-drawer>
  </div>
</template>

<script>
  import { listPhotonote, getPhotonote,handlePhotonote, delPhotonote, addPhotonote, updatePhotonote } from "@/api/laboratory/photonote";
  import { done } from 'element-ui'
  import pendingInfo from "./pendingInfo.vue";

  export default {
    name: "Photonote",
    components: {
      pendingInfo,
    },
    data() {
      return {
        tableButtonType:this.hasPermiDom(['laboratory:photonote:query','laboratory:photonote:edit']),
        //页面状态
        pageType:1,
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 随手拍记录表格数据
        photonoteList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize:20,
          imgUrl: null,
          handleUser: null,
          handleTime: null,
          handleStatus: 0,
          deptId: null,
          deptName: null,
          userId: null,
          subjectId: null,
          describe: null
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
        },
        //  关联实验室弹窗开关
        drawer:false,
        drawerData:{
        }
      };
    },
    created() {
      this.getList();
    },
    methods: {
      offPage(){
        this.pageType = 1;
        this.getList();
      },
      //关联实验室弹窗
      drawerBoxOn(row){
        this.pageType = 2;
        // this.drawer = true;
        this.drawerData = row;
        if(this.drawerData.imgUrl){
          this.drawerData.imgUrl = this.drawerData.imgUrl.split(',')
        }
      },
      //关闭弹窗
      offDrawer(){
        this.$refs.drawer.closeDrawer();
      },
      //弹窗关闭前回调
      handleClose(done) {
        this.$confirm('确认关闭吗？')
          .then(_ => {
            done();
          })
          .catch(_ => {});
      },
      //返回按钮
      backPage(){
        this.$parent.pageOff();
      },
      /** 查询随手拍记录列表 */
      getList() {
        this.loading = true;
        listPhotonote(this.queryParams).then( response => {
          this.photonoteList =  response.rows;
          this.total =  response.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          imgUrl: null,
          handleUser: null,
          handleTime: null,
          handleStatus: 0,
          deptId: null,
          deptName: null,
          userId: null,
          remark: null,
          createBy: null,
          createTime: null,
          updateBy: null,
          updateTime: null,
          subjectId: null,
          describe: null
        };
        this.resetForm("form");
      },
      /**处理随手拍 */
      handle(id){
          handlePhotonote(id).then( response => {
            this.msgSuccess("请求成功成功");
            this.getList()
            this.drawer=!this.drawer;
          });
      },

      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加随手拍记录";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids
        getPhotonote(id).then( response => {
          this.form =  response.data;
          this.open = true;
          this.title = "修改随手拍记录";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updatePhotonote(this.form).then( response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addPhotonote(this.form).then( response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$confirm('是否确认删除随手拍记录?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPhotonote(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('laboratory/photonote/export', {
          ...this.queryParams
        }, `laboratory_photonote.xlsx`)
      }
    }
  };
</script>

<style scoped lang="scss">
  .photonote-pending {
    flex:1;
    display: flex!important;
    flex-direction: column;
    .photonote-pending-page{
      flex:1;
      display: flex!important;
      flex-direction: column;
      .button-box{
        width:90px;
        display: flex;
      }
    }
  }
</style>
